/**
 * SDRangel
 * This is the web REST/JSON API of SDRangel SDR software. SDRangel is an Open Source Qt5/OpenGL 3.0+ (4.3+ in Windows) GUI and server Software Defined Radio and signal analyzer in software. It supports Airspy, BladeRF, HackRF, LimeSDR, PlutoSDR, RTL-SDR, SDRplay RSP1 and FunCube     ---   Limitations and specifcities:       * In SDRangel GUI the first Rx device set cannot be deleted. Conversely the server starts with no device sets and its number of device sets can be reduced to zero by as many calls as necessary to /sdrangel/deviceset with DELETE method.   * Stopping instance i.e. /sdrangel with DELETE method is a server only feature. It allows stopping the instance nicely.   * Preset import and export from/to file is a server only feature.   * The following channels are not implemented (status 501 is returned): ATV demodulator, Channel Analyzer, Channel Analyzer NG, LoRa demodulator, TCP source   * The content type returned is always application/json except in the following cases:     * An incorrect URL was specified: this document is returned as text/html with a status 400    --- 
 *
 * OpenAPI spec version: 4.0.0
 * Contact: f4exb06@gmail.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


#include "SWGLoggingInfo.h"

#include "SWGHelpers.h"

#include <QJsonDocument>
#include <QJsonArray>
#include <QObject>
#include <QDebug>

namespace SWGSDRangel {

SWGLoggingInfo::SWGLoggingInfo(QString* json) {
    init();
    this->fromJson(*json);
}

SWGLoggingInfo::SWGLoggingInfo() {
    init();
}

SWGLoggingInfo::~SWGLoggingInfo() {
    this->cleanup();
}

void
SWGLoggingInfo::init() {
    console_level = new QString("");
    file_level = new QString("");
    dump_to_file = 0;
    file_name = new QString("");
}

void
SWGLoggingInfo::cleanup() {
    
    if(console_level != nullptr) {
        delete console_level;
    }

    if(file_level != nullptr) {
        delete file_level;
    }


    if(file_name != nullptr) {
        delete file_name;
    }
}

SWGLoggingInfo*
SWGLoggingInfo::fromJson(QString &json) {
    QByteArray array (json.toStdString().c_str());
    QJsonDocument doc = QJsonDocument::fromJson(array);
    QJsonObject jsonObject = doc.object();
    this->fromJsonObject(jsonObject);
    return this;
}

void
SWGLoggingInfo::fromJsonObject(QJsonObject &pJson) {
    ::SWGSDRangel::setValue(&console_level, pJson["consoleLevel"], "QString", "QString");
    ::SWGSDRangel::setValue(&file_level, pJson["fileLevel"], "QString", "QString");
    ::SWGSDRangel::setValue(&dump_to_file, pJson["dumpToFile"], "qint32", "");
    ::SWGSDRangel::setValue(&file_name, pJson["fileName"], "QString", "QString");
}

QString
SWGLoggingInfo::asJson ()
{
    QJsonObject* obj = this->asJsonObject();
    
    QJsonDocument doc(*obj);
    QByteArray bytes = doc.toJson();
    return QString(bytes);
}

QJsonObject*
SWGLoggingInfo::asJsonObject() {
    QJsonObject* obj = new QJsonObject();
    
    toJsonValue(QString("consoleLevel"), console_level, obj, QString("QString"));

    toJsonValue(QString("fileLevel"), file_level, obj, QString("QString"));

    obj->insert("dumpToFile", QJsonValue(dump_to_file));

    toJsonValue(QString("fileName"), file_name, obj, QString("QString"));

    return obj;
}

QString*
SWGLoggingInfo::getConsoleLevel() {
    return console_level;
}
void
SWGLoggingInfo::setConsoleLevel(QString* console_level) {
    this->console_level = console_level;
}

QString*
SWGLoggingInfo::getFileLevel() {
    return file_level;
}
void
SWGLoggingInfo::setFileLevel(QString* file_level) {
    this->file_level = file_level;
}

qint32
SWGLoggingInfo::getDumpToFile() {
    return dump_to_file;
}
void
SWGLoggingInfo::setDumpToFile(qint32 dump_to_file) {
    this->dump_to_file = dump_to_file;
}

QString*
SWGLoggingInfo::getFileName() {
    return file_name;
}
void
SWGLoggingInfo::setFileName(QString* file_name) {
    this->file_name = file_name;
}


}

