/**
 * SDRangel
 * This is the web REST/JSON API of SDRangel SDR software. SDRangel is an Open Source Qt5/OpenGL 3.0+ (4.3+ in Windows) GUI and server Software Defined Radio and signal analyzer in software. It supports Airspy, BladeRF, HackRF, LimeSDR, PlutoSDR, RTL-SDR, SDRplay RSP1 and FunCube     ---   Limitations and specifcities:       * In SDRangel GUI the first Rx device set cannot be deleted. Conversely the server starts with no device sets and its number of device sets can be reduced to zero by as many calls as necessary to /sdrangel/deviceset with DELETE method.   * Stopping instance i.e. /sdrangel with DELETE method is a server only feature. It allows stopping the instance nicely.   * Preset import and export from/to file is a server only feature.   * The following channels are not implemented (status 501 is returned): ATV demodulator, Channel Analyzer, Channel Analyzer NG, LoRa demodulator, TCP source   * The content type returned is always application/json except in the following cases:     * An incorrect URL was specified: this document is returned as text/html with a status 400    --- 
 *
 * OpenAPI spec version: 4.0.0
 * Contact: f4exb06@gmail.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


#include "SWGRtlSdrSettings.h"

#include "SWGHelpers.h"

#include <QJsonDocument>
#include <QJsonArray>
#include <QObject>
#include <QDebug>

namespace SWGSDRangel {

SWGRtlSdrSettings::SWGRtlSdrSettings(QString* json) {
    init();
    this->fromJson(*json);
}

SWGRtlSdrSettings::SWGRtlSdrSettings() {
    init();
}

SWGRtlSdrSettings::~SWGRtlSdrSettings() {
    this->cleanup();
}

void
SWGRtlSdrSettings::init() {
    dev_sample_rate = 0;
    low_sample_rate = 0;
    center_frequency = 0L;
    gain = 0;
    lo_ppm_correction = 0;
    log2_decim = 0;
    fc_pos = 0;
    dc_block = 0;
    iq_imbalance = 0;
    agc = 0;
    no_mod_mode = 0;
    transverter_mode = 0;
    transverter_delta_frequency = 0L;
}

void
SWGRtlSdrSettings::cleanup() {
    












}

SWGRtlSdrSettings*
SWGRtlSdrSettings::fromJson(QString &json) {
    QByteArray array (json.toStdString().c_str());
    QJsonDocument doc = QJsonDocument::fromJson(array);
    QJsonObject jsonObject = doc.object();
    this->fromJsonObject(jsonObject);
    return this;
}

void
SWGRtlSdrSettings::fromJsonObject(QJsonObject &pJson) {
    ::SWGSDRangel::setValue(&dev_sample_rate, pJson["devSampleRate"], "qint32", "");
    ::SWGSDRangel::setValue(&low_sample_rate, pJson["lowSampleRate"], "qint32", "");
    ::SWGSDRangel::setValue(&center_frequency, pJson["centerFrequency"], "qint64", "");
    ::SWGSDRangel::setValue(&gain, pJson["gain"], "qint32", "");
    ::SWGSDRangel::setValue(&lo_ppm_correction, pJson["loPpmCorrection"], "qint32", "");
    ::SWGSDRangel::setValue(&log2_decim, pJson["log2Decim"], "qint32", "");
    ::SWGSDRangel::setValue(&fc_pos, pJson["fcPos"], "qint32", "");
    ::SWGSDRangel::setValue(&dc_block, pJson["dcBlock"], "qint32", "");
    ::SWGSDRangel::setValue(&iq_imbalance, pJson["iqImbalance"], "qint32", "");
    ::SWGSDRangel::setValue(&agc, pJson["agc"], "qint32", "");
    ::SWGSDRangel::setValue(&no_mod_mode, pJson["noModMode"], "qint32", "");
    ::SWGSDRangel::setValue(&transverter_mode, pJson["transverterMode"], "qint32", "");
    ::SWGSDRangel::setValue(&transverter_delta_frequency, pJson["transverterDeltaFrequency"], "qint64", "");
}

QString
SWGRtlSdrSettings::asJson ()
{
    QJsonObject* obj = this->asJsonObject();
    
    QJsonDocument doc(*obj);
    QByteArray bytes = doc.toJson();
    return QString(bytes);
}

QJsonObject*
SWGRtlSdrSettings::asJsonObject() {
    QJsonObject* obj = new QJsonObject();
    
    obj->insert("devSampleRate", QJsonValue(dev_sample_rate));

    obj->insert("lowSampleRate", QJsonValue(low_sample_rate));

    obj->insert("centerFrequency", QJsonValue(center_frequency));

    obj->insert("gain", QJsonValue(gain));

    obj->insert("loPpmCorrection", QJsonValue(lo_ppm_correction));

    obj->insert("log2Decim", QJsonValue(log2_decim));

    obj->insert("fcPos", QJsonValue(fc_pos));

    obj->insert("dcBlock", QJsonValue(dc_block));

    obj->insert("iqImbalance", QJsonValue(iq_imbalance));

    obj->insert("agc", QJsonValue(agc));

    obj->insert("noModMode", QJsonValue(no_mod_mode));

    obj->insert("transverterMode", QJsonValue(transverter_mode));

    obj->insert("transverterDeltaFrequency", QJsonValue(transverter_delta_frequency));

    return obj;
}

qint32
SWGRtlSdrSettings::getDevSampleRate() {
    return dev_sample_rate;
}
void
SWGRtlSdrSettings::setDevSampleRate(qint32 dev_sample_rate) {
    this->dev_sample_rate = dev_sample_rate;
}

qint32
SWGRtlSdrSettings::getLowSampleRate() {
    return low_sample_rate;
}
void
SWGRtlSdrSettings::setLowSampleRate(qint32 low_sample_rate) {
    this->low_sample_rate = low_sample_rate;
}

qint64
SWGRtlSdrSettings::getCenterFrequency() {
    return center_frequency;
}
void
SWGRtlSdrSettings::setCenterFrequency(qint64 center_frequency) {
    this->center_frequency = center_frequency;
}

qint32
SWGRtlSdrSettings::getGain() {
    return gain;
}
void
SWGRtlSdrSettings::setGain(qint32 gain) {
    this->gain = gain;
}

qint32
SWGRtlSdrSettings::getLoPpmCorrection() {
    return lo_ppm_correction;
}
void
SWGRtlSdrSettings::setLoPpmCorrection(qint32 lo_ppm_correction) {
    this->lo_ppm_correction = lo_ppm_correction;
}

qint32
SWGRtlSdrSettings::getLog2Decim() {
    return log2_decim;
}
void
SWGRtlSdrSettings::setLog2Decim(qint32 log2_decim) {
    this->log2_decim = log2_decim;
}

qint32
SWGRtlSdrSettings::getFcPos() {
    return fc_pos;
}
void
SWGRtlSdrSettings::setFcPos(qint32 fc_pos) {
    this->fc_pos = fc_pos;
}

qint32
SWGRtlSdrSettings::getDcBlock() {
    return dc_block;
}
void
SWGRtlSdrSettings::setDcBlock(qint32 dc_block) {
    this->dc_block = dc_block;
}

qint32
SWGRtlSdrSettings::getIqImbalance() {
    return iq_imbalance;
}
void
SWGRtlSdrSettings::setIqImbalance(qint32 iq_imbalance) {
    this->iq_imbalance = iq_imbalance;
}

qint32
SWGRtlSdrSettings::getAgc() {
    return agc;
}
void
SWGRtlSdrSettings::setAgc(qint32 agc) {
    this->agc = agc;
}

qint32
SWGRtlSdrSettings::getNoModMode() {
    return no_mod_mode;
}
void
SWGRtlSdrSettings::setNoModMode(qint32 no_mod_mode) {
    this->no_mod_mode = no_mod_mode;
}

qint32
SWGRtlSdrSettings::getTransverterMode() {
    return transverter_mode;
}
void
SWGRtlSdrSettings::setTransverterMode(qint32 transverter_mode) {
    this->transverter_mode = transverter_mode;
}

qint64
SWGRtlSdrSettings::getTransverterDeltaFrequency() {
    return transverter_delta_frequency;
}
void
SWGRtlSdrSettings::setTransverterDeltaFrequency(qint64 transverter_delta_frequency) {
    this->transverter_delta_frequency = transverter_delta_frequency;
}


}

